//+------------------------------------------------------------------+
//|                                                 DT_ZZ_Impuls.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, klot."
#property link      "klot@mail.ru"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 LimeGreen
#property indicator_level1 0.0
//---- indicator parameters
extern int ExtDepth=6;
extern double scale=3000;
extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;
extern bool   alertsNotify     = false;
extern string soundFile        = "alert2.wav";
//---- indicator buffers
double zzL[];
double zzH[];
double zz[];
double trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(4);
   SetIndexBuffer(0,zz);
   SetIndexBuffer(1,zzH);
   SetIndexBuffer(2,zzL);
   SetIndexBuffer(3,trend);
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
//---- indicator short name
   IndicatorShortName("DT_Impuls("+ExtDepth+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i,shift,pos,lasthighpos,lastlowpos,curhighpos,curlowpos;
   double curlow,curhigh,lasthigh,lastlow;
   double min, max;
   int s;
   double h;
   
   lasthighpos=Bars-1; lastlowpos=Bars-1;
   lastlow=Close[Bars-1];lasthigh=Close[Bars-1];
  for(shift=Bars-ExtDepth; shift>=0; shift--)
    {
      zz[shift]  = 0;
      zzH[shift] = 0;
      zzL[shift] = 0;
      trend[shift] = trend[shift+1];
      curlowpos=iLowest(NULL,0,MODE_CLOSE,ExtDepth,shift);
      curlow=Close[curlowpos];
      curhighpos=iHighest(NULL,0,MODE_CLOSE,ExtDepth,shift);
      curhigh=Close[curhighpos];
      //------------------------------------------------
      if( curlow>=lastlow ) { lastlow=curlow; }
      else { 
            // 
            if( lasthighpos>curlowpos  ) { 
               zzL[curlowpos]=curlow;
               min=100000; pos=lasthighpos;
               for(i=lasthighpos; i>=curlowpos; i--) { 
                    if (zzL[i]==0.0) continue;
                    if (zzL[i]<=min) { min=zzL[i]; pos=i; }
               } 
            } 
            lastlowpos=curlowpos;
            lastlow=curlow; 
      }
      //--- high
      if( curhigh<=lasthigh )  { lasthigh=curhigh;}
      else {  
            //  
            if( lastlowpos>curhighpos ) {  
               zzH[curhighpos]=curhigh;
               max=-100000; pos=lastlowpos;
               for(i=lastlowpos; i>=curhighpos; i--) { 
                    if (zzH[i]==0.0) continue;
                    if (zzH[i]>=max) { max=zzH[i]; pos=i; }
               } 
            }
            lasthighpos=curhighpos;
            lasthigh=curhigh;
      }    
      //---
      if( lasthighpos>=lastlowpos  ) {
         h=(zzH[lasthighpos]-zzL[lastlowpos]);
         s=(lasthighpos-shift); 
         zz[shift]=-MathArctan(scale*(h/(1.0*s)));
      }
      if( lastlowpos>=lasthighpos ) {
         h=(zzH[lasthighpos]-zzL[lastlowpos]);
         s=(lastlowpos-shift);
         zz[shift]=MathArctan(scale*(h/(1.0*s)));
      }
      if (zz[shift]<0) trend[shift] = -1;
      if (zz[shift]>0) trend[shift] =  1;
    //----------------------------------------------------------------------
  }
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("crossed 0 up");
      else  doAlert("crossed 0 down");       
   }       
  
  return(0);
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," DT ZZ impuls ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," DT ZZ impuls "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}